with amounts as (
  select
    user_agent,
    count(*) as count
  from logs
  where tls_version = "TLSv1" OR tls_version = "TLSv1.1"
  group by user_agent
),
max as (
  select max(count) as value
  from amounts
)
select
  user_agent,
  count,
  printf('%.' || (count * 30 / max.value) || 'c', '*') as bar
from amounts, max
order by count;

